'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _require = require('lsd-observable');

var ObservableEvent = _require.ObservableEvent;

var ActivityTracker = function ActivityTracker() {
    var _this = this;

    _classCallCheck(this, ActivityTracker);

    this.uiEvent = new ObservableEvent();
    this.windowEvent = new ObservableEvent();
    document.addEventListener('click', function (e) {
        return _this.uiEvent.send(e);
    });
    document.addEventListener('mousemove', function (e) {
        return _this.uiEvent.send(e);
    });
    document.addEventListener('keypress', function (e) {
        return _this.uiEvent.send(e);
    });
    document.addEventListener('visibilitychange', function (e) {
        return _this.windowEvent.send(!document.hidden);
    });
};

module.exports = ActivityTracker;