'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var React = require('react');

var _require = require('react');

var PropTypes = _require.PropTypes;

var _require2 = require('immutable');

var List = _require2.List;

var moment = require('moment');
var EntityList = require('./EntityList');
var EntityListItem = function EntityListItem() {
    return require('./EntityListItem');
};

var _require3 = require('lsd-metadata');

var Reference = _require3.Reference;
var Types = _require3.Types;


var DisplayItem = React.createClass({
    displayName: 'DisplayItem',

    render: function render() {
        return React.createElement(
            'span',
            { className: this.props.className },
            this.displayValue()
        );
    },

    getDefaultProps: function getDefaultProps() {
        return {
            value: ''
        };
    },

    displayValue: function displayValue() {
        var propDesc = this.props.propDesc;
        var type = propDesc.type;
        var value = this.props.value;
        if (type === String) {
            return value;
        }
        if (type === Number) {
            return value;
        }
        if (type === Date) {
            var displayFormat = "DD MMM YY";
            return moment(value).format(displayFormat);
        }
        if (type === List) {
            var _ret = function () {
                var EntityListItemType = EntityListItem();
                var displayItemFn = function displayItemFn(item) {
                    return React.createElement(EntityListItemType, { item: item });
                };
                return {
                    v: React.createElement(EntityList, { items: value, itemType: propDesc.itemType, displayItem: displayItemFn })
                };
            }();

            if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
        }
        if (Types.isSameType(type, Reference)) {
            if (value) {
                var entity = this.context.getEntityManager(propDesc.itemType).get(value);
                return entity.shortSummary;
            } else {
                return "";
            }
        }
        if (type.values) {
            return value ? value.label : "";
        }

        return value.toString();
    }
});

DisplayItem.propTypes = {
    propDesc: PropTypes.object.isRequired,
    value: PropTypes.any
};

DisplayItem.contextTypes = {
    getEntityManager: PropTypes.func
};

module.exports = DisplayItem;