'use strict';

var React = require('react');

var _require = require('react');

var PropTypes = _require.PropTypes;

var _require2 = require('immutable');

var List = _require2.List;

var _require3 = require('react-bootstrap');

var ListGroup = _require3.ListGroup;
var ListGroupItem = _require3.ListGroupItem;


var EntityList = React.createClass({
    displayName: 'EntityList',

    render: function render() {
        var _this = this;

        var renderItem = function renderItem(item, index) {
            return React.createElement(
                ListGroupItem,
                { key: item.id || index,
                    active: item.id === _this.props.selectedItemId,
                    onClick: _this.onClick.bind(_this, item) },
                _this.props.displayItem(item)
            );
        };
        var items = this.props.items;

        return React.createElement(
            ListGroup,
            null,
            items.map(renderItem)
        );
    },

    getDefaultProps: function getDefaultProps() {
        return { items: [] };
    },

    onClick: function onClick(item) {
        console.log('onClick', item);

        var onSelect = this.props.onSelect;
        if (onSelect) {
            onSelect(item);
        }
    }
});

EntityList.propTypes = {
    items: PropTypes.instanceOf(List).isRequired,
    selectedItemId: PropTypes.string,
    onSelect: PropTypes.func,
    displayItem: PropTypes.func.isRequired
};

module.exports = EntityList;