'use strict';

var React = require('react');

var _require = require('react');

var PropTypes = _require.PropTypes;

var _require2 = require('immutable');

var List = _require2.List;

var _require3 = require('react-bootstrap');

var Button = _require3.Button;
var ListGroup = _require3.ListGroup;
var ListGroupItem = _require3.ListGroupItem;

var _require4 = require('lsd-metadata');

var Types = _require4.Types;


var EntityListEditable = React.createClass({
    displayName: 'EntityListEditable',

    render: function render() {
        var _this = this;

        var renderDisplayItem = function renderDisplayItem(item, index) {
            return React.createElement(
                ListGroupItem,
                { key: item.id || index,
                    onClick: _this.onEdit.bind(_this, item) },
                _this.props.displayItem(item)
            );
        };
        var renderEditItem = function renderEditItem(item, index) {
            return React.createElement(
                ListGroupItem,
                { key: item.id || index },
                _this.props.editItem(item, _this.onSave, _this.onCancelEdit)
            );
        };

        var renderItem = function renderItem(item, index) {
            var isEditing = item === _this.state.itemEdited;
            return isEditing ? renderEditItem(item, index) : renderDisplayItem(item, index);
        };

        var items = this.props.items;
        var itemsToRender = this.state.itemEditedIsNew ? items.insert(this.state.indexEdited, this.state.itemEdited) : items;
        var buttonText = 'Add ' + this.props.entityManager.typeName;
        var listItems = itemsToRender.map(renderItem);
        var button = React.createElement(
            Button,
            { bsSize: 'small', onClick: this.onAdd },
            buttonText
        );

        switch (this.props.addButtonPosition) {
            case 'top':
                return React.createElement(
                    'div',
                    null,
                    React.createElement(
                        'div',
                        { className: 'list-add-button-top' },
                        button
                    ),
                    React.createElement(
                        ListGroup,
                        null,
                        listItems
                    )
                );

            default:
                return React.createElement(
                    'div',
                    null,
                    React.createElement(
                        ListGroup,
                        null,
                        listItems,
                        React.createElement(
                            ListGroupItem,
                            { key: 'add' },
                            button
                        )
                    )
                );
        }
    },

    getInitialState: function getInitialState() {
        return {
            indexEdited: null,
            itemEdited: null,
            itemEditedIsNew: null
        };
    },

    onEdit: function onEdit(item) {
        console.log('onEdit', item);
        this.setState({ itemEdited: item, indexEdited: this.props.items.indexOf(item), itemEditedIsNew: false });
    },

    onAdd: function onAdd() {
        console.log('onAdd');
        var item = this.props.entityManager.newInstance();
        var addedItemIndex = this.props.addButtonPosition === 'top' ? 0 : this.props.items.size;
        this.setState({ itemEdited: item, indexEdited: addedItemIndex, itemEditedIsNew: true });
    },

    onSave: function onSave(updatedItem) {
        if (this.props.onChangeList) {
            var updatedList = this.state.itemEditedIsNew ? this.props.items.insert(this.state.indexEdited, updatedItem) : this.props.items.set(this.state.indexEdited, updatedItem);
            this.props.onChangeList(updatedList);
        }

        if (this.props.onChangeItem) {
            this.props.onChangeItem(updatedItem);
        }

        this.setState(this.getInitialState());
    },

    onCancelEdit: function onCancelEdit() {
        this.setState(this.getInitialState());
    }
});

EntityListEditable.propTypes = {
    items: PropTypes.instanceOf(List).isRequired,
    entityManager: PropTypes.object.isRequired,
    onChangeList: PropTypes.func,
    onChangeItem: PropTypes.func,
    displayItem: PropTypes.func.isRequired,
    editItem: PropTypes.func.isRequired,
    addButtonPosition: PropTypes.string
};

module.exports = EntityListEditable;