'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var React = require('react');

var _require = require('react');

var PropTypes = _require.PropTypes;

var DisplayItem = require('./DisplayItem');

var EntityListItem = function EntityListItem(_ref) {
    var item = _ref.item;

    if (item.shortSummary) {
        return React.createElement(
            'span',
            null,
            item.shortSummary
        );
    } else {
        var _ret = function () {
            var entityDescriptor = item.constructor.entityDescriptor;
            if (entityDescriptor) {
                var displayProps = entityDescriptor.displayProperties;
                var displayItem = function displayItem(dp, index) {
                    var value = item[dp];
                    var propDesc = entityDescriptor.propertyDescriptor(dp);
                    return React.createElement(DisplayItem, { className: 'spaced-1', value: value, propDesc: propDesc, key: index });
                };
                return {
                    v: React.createElement(
                        'span',
                        null,
                        ' ',
                        displayProps.map(displayItem),
                        ' '
                    )
                };
            } else {
                return {
                    v: React.createElement(
                        'span',
                        null,
                        item.toString()
                    )
                };
            }
        }();

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
    }
};

EntityListItem.propTypes = {
    item: PropTypes.any.isRequired
};

module.exports = EntityListItem;