'use strict';

var _ = require('lodash');
var React = require('react');

var _require = require('react');

var PropTypes = _require.PropTypes;

var _require2 = require('immutable');

var List = _require2.List;

var _require3 = require('react-bootstrap');

var Table = _require3.Table;

var EntityTableRowGroup = require('./EntityTableRowGroup');

var _require4 = require('./Util');

var parseProp = _require4.parseProp;


var EntityTable = React.createClass({
    displayName: 'EntityTable',


    render: function render() {
        var _this = this;

        return React.createElement(
            Table,
            { striped: true, bordered: true, condensed: true, hover: true },
            React.createElement(
                'thead',
                null,
                React.createElement(
                    'tr',
                    null,
                    this.propertiesToShow().map(function (propInfo, index) {
                        return _this.headerCell(propInfo.name, index);
                    })
                )
            ),
            React.createElement(EntityTableRowGroup, { items: this.props.items, propertiesToShow: this.props.propertiesToShow }),
            this.props.children
        );
    },

    entityDescriptor: function entityDescriptor() {
        var items = this.props.items;
        var entityDescriptor = this.props.entityDescriptor || items.get(0) && items.get(0).constructor.entityDescriptor;
        if (!entityDescriptor) throw new Error('EntityDescriptor required'); //TODO show no data message if no items and no entity descriptor
        return entityDescriptor;
    },

    propertiesToShow: function propertiesToShow() {
        return (this.props.propertiesToShow || this.entityDescriptor().displayProperties).map(parseProp);
    },

    headerCell: function headerCell(name, index) {
        return React.createElement(
            'th',
            { key: index },
            this.entityDescriptor().propertyDescriptor(name).label
        );
    }

});

EntityTable.propTypes = {
    items: PropTypes.instanceOf(List), //TODO required but need to specify partial element for cloning
    entityDescriptor: PropTypes.object,
    propertiesToShow: PropTypes.arrayOf(PropTypes.string)
};

module.exports = EntityTable;