'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _ = require('lodash');
var React = require('react');

var _require = require('react');

var PropTypes = _require.PropTypes;

var _require2 = require('react-bootstrap');

var Button = _require2.Button;
var ButtonToolbar = _require2.ButtonToolbar;

var FormItem = require('./FormItem');

var EntityView = React.createClass({
    displayName: 'EntityView',
    getDefaultProps: function getDefaultProps() {
        return { propertyViews: {} };
    },


    getInitialState: function getInitialState() {
        return { updatedEntity: null, errors: {} };
    },

    componentWillReceiveProps: function componentWillReceiveProps() {
        this.setState(this.getInitialState());
    },

    entityAndDescriptor: function entityAndDescriptor() {
        var entity = this.state.updatedEntity || this.props.entity;
        var entityDescriptor = entity.constructor.entityDescriptor || this.props.entityDescriptor;
        if (!entityDescriptor) throw new Error('EntityDescriptor required');
        return [entity, entityDescriptor];
    },

    render: function render() {
        var _this = this;

        var _entityAndDescriptor = this.entityAndDescriptor();

        var _entityAndDescriptor2 = _slicedToArray(_entityAndDescriptor, 2);

        var entity = _entityAndDescriptor2[0];
        var entityDescriptor = _entityAndDescriptor2[1];

        var propertyNames = this.props.propertiesToShow || entityDescriptor.displayProperties;
        return React.createElement(
            'div',
            null,
            React.createElement(
                'h2',
                null,
                this.heading(entity, entityDescriptor)
            ),
            React.createElement(
                'div',
                null,
                propertyNames.map(function (name) {
                    return _this.formItem(entityDescriptor.propertyDescriptor(name), entity[name]);
                })
            ),
            React.createElement(
                ButtonToolbar,
                null,
                React.createElement(
                    Button,
                    { bsStyle: 'primary', onClick: this.onSave },
                    'Save'
                ),
                this.props.onCancel ? React.createElement(
                    Button,
                    { onClick: this.props.onCancel },
                    'Cancel'
                ) : ''
            )
        );
    },

    heading: function heading(entity, entityDescriptor) {
        if (this.props.hasOwnProperty("heading")) {
            return this.props.heading ? React.createElement(
                'h2',
                null,
                this.props.heading
            ) : "";
        }

        var entityName = entityDescriptor.name;
        return _.hasIn(entity, 'id') ? entity.id ? '' + entity.shortSummary : 'New ' + entityName : entityName;
    },

    onChange: function onChange(name, value) {
        var oldEntity = this.state.updatedEntity || this.props.entity;
        var updatedEntity = oldEntity.setData(name, value);

        var _entityAndDescriptor3 = this.entityAndDescriptor();

        var _entityAndDescriptor4 = _slicedToArray(_entityAndDescriptor3, 2);

        var entity = _entityAndDescriptor4[0];
        var entityDescriptor = _entityAndDescriptor4[1];


        var errors = entityDescriptor.validate(updatedEntity);
        this.setState({ updatedEntity: updatedEntity, errors: errors });
    },

    onSave: function onSave(e) {
        e.preventDefault();
        var entity = this.state.updatedEntity;
        if (entity) {
            console.log('save', entity.toJS());
            this.props.onSave(entity);
            this.setState({ updatedEntity: null });
        } else {
            console.log('save', 'no change');
        }
    },

    formItem: function formItem(propDesc, value) {
        var changeFn = this.onChange.bind(this, propDesc.name);
        var error = this.state.errors[propDesc.name] && this.state.errors[propDesc.name][0];
        return React.createElement(FormItem, { key: propDesc.name, type: propDesc.type, editable: propDesc.editable, onChange: changeFn,
            value: value, label: propDesc.label,
            placeholder: propDesc.description, help: propDesc.help, error: error,
            propDesc: propDesc, viewElement: this.props.propertyViews[propDesc.name] });
    }
});

EntityView.propTypes = {
    entity: PropTypes.object.isRequired,
    onSave: PropTypes.func.isRequired,
    onCancel: PropTypes.func,
    entityDescriptor: PropTypes.object,
    heading: PropTypes.string,
    propertiesToShow: PropTypes.arrayOf(PropTypes.string),
    propertyViews: PropTypes.objectOf(PropTypes.element)
};

module.exports = EntityView;