'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var React = require('react');

var _require = require('react');

var PropTypes = _require.PropTypes;

var GoogleLogin = require('react-google-login')['default'];

var _require2 = require('lsd-observable');

var ObservableEvent = _require2.ObservableEvent;


var GoogleSignin = React.createClass({
    displayName: 'GoogleSignin',

    render: function render() {
        return React.createElement(GoogleLogin, { callback: this._onSignIn, clientId: this.props.clientId, cssClass: 'btn btn-default', buttonText: 'Sign in with Google' });
    },

    getDefaultProps: function getDefaultProps() {
        return { accounts: [] };
    },

    _onSignIn: function _onSignIn(auth) {
        var authResponse = auth.getAuthResponse();
        var event = new CustomEvent('googleSignIn', { detail: { authResponse: authResponse } });
        document.dispatchEvent(event);
    }
});

GoogleSignin.propTypes = {
    clientId: PropTypes.string.isRequired
};

GoogleSignin.Tracker = function GoogleSigninTracker() {
    var _this = this;

    _classCallCheck(this, GoogleSigninTracker);

    this.signIn = new ObservableEvent();
    this.signOut = new ObservableEvent();
    document.addEventListener('googleSignIn', function (e) {
        return _this.signIn.send(e.detail.authResponse);
    });
    document.addEventListener('googleSignOut', function (e) {
        return _this.signOut.send(null);
    });
};

module.exports = GoogleSignin;