"use strict";

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var React = require('react');
var RouterMixin = require('react-router-component').RouterMixin;
var RouteRenderingMixin = require('react-router-component').RouteRenderingMixin;
var assign = Object.assign || require('object-assign');
var omit = require('object.omit');

// These are keys to omit - useful for preventing 15.2.0 warning regarding unknown props on DOM els
var PROP_KEYS = ['component'].concat(Object.keys(RouterMixin.propTypes)).concat(Object.keys(RouteRenderingMixin.propTypes));

var PersistentRouter = React.createClass({

    mixins: [RouterMixin, RouteRenderingMixin],

    displayName: 'PersistentRouter',

    propTypes: {
        component: React.PropTypes.oneOfType([React.PropTypes.string, React.PropTypes.element])
    },

    getRoutes: function getRoutes(props) {
        return props.children;
    },

    getDefaultProps: function getDefaultProps() {
        return {
            component: 'div'
        };
    },

    render: function render() {
        var cache = this.handlerCache || (this.handlerCache = new Map());
        console.log('CachingRouter', 'state', this.state);
        var matchPath = this.state.match.matchedPath;

        var currentHandler = cache.get(matchPath);
        if (!currentHandler) {
            currentHandler = this.renderRouteHandler();
            cache.set(matchPath, currentHandler);
        }

        var handlers = [];
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
            for (var _iterator = cache.entries()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var _step$value = _slicedToArray(_step.value, 2);

                var p = _step$value[0];
                var handler = _step$value[1];

                var show = handler === currentHandler;
                handlers.push(React.createElement(
                    'div',
                    { key: p, style: show ? {} : { display: 'none' } },
                    handler
                ));
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion && _iterator.return) {
                    _iterator.return();
                }
            } finally {
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }

        if (!this.props.component) {
            return currentHandler;
        } else {
            // Pass all props except this component to the Router (containing div/body) and the children,
            // which are swapped out by the route handler.
            var props = assign({}, this.props);
            props = omit(props, PROP_KEYS);
            return React.createElement(this.props.component, props, handlers);
        }
    }
});

module.exports = PersistentRouter;