'use strict';

var _ = require('lodash');
var React = require('react');

var _require = require('react');

var PropTypes = _require.PropTypes;

var FormItem = require('./FormItem');

var ReportView = React.createClass({
    displayName: 'ReportView',


    render: function render() {
        var _this = this;

        var entity = this.props.entity;
        var entityDescriptor = entity.constructor.entityDescriptor || this.props.entityDescriptor;
        if (!entityDescriptor) throw new Error('EntityDescriptor required');
        var entityName = entityDescriptor.name;
        var propertyNames = this.props.propertiesToShow || entityDescriptor.displayProperties;
        var heading = entityName + ' ' + entity.shortSummary;
        return React.createElement(
            'div',
            null,
            React.createElement(
                'h2',
                null,
                heading
            ),
            React.createElement(
                'div',
                null,
                propertyNames.map(function (name) {
                    return _this.formItem(entityDescriptor.propertyDescriptor(name), entity[name]);
                })
            )
        );
    },

    formItem: function formItem(propDesc, value) {
        if (propDesc.type === List) {}
        return React.createElement(FormItem, { key: propDesc.name, type: propDesc.type, editable: false, value: value, label: propDesc.label,
            help: propDesc.help, propDesc: propDesc });
    }
});

ReportView.propTypes = {
    entity: PropTypes.object.isRequired,
    entityDescriptor: PropTypes.object,
    propertiesToShow: PropTypes.arrayOf(PropTypes.string)
};

module.exports = ReportView;