'use strict';

var React = require('react');

var _require = require('react');

var PropTypes = _require.PropTypes;

var _require2 = require('immutable');

var List = _require2.List;

var _require3 = require('react-bootstrap');

var ListGroup = _require3.ListGroup;
var ListGroupItem = _require3.ListGroupItem;

var EntityListItem = require('./EntityListItem');
var SimpleView = require('./SimpleView');

var SimpleListEditable = React.createClass({
    displayName: 'SimpleListEditable',

    render: function render() {
        var _this = this;

        var renderDisplayItem = function renderDisplayItem(item, index) {
            return React.createElement(
                ListGroupItem,
                { key: item && item.id || index, onClick: _this.onEdit.bind(_this, index) },
                item ? React.createElement(EntityListItem, { item: item }) : React.createElement(
                    'span',
                    { className: 'placeholder' },
                    'Add another...'
                )
            );
        };
        var renderEditItem = function renderEditItem(item, index) {
            return React.createElement(
                ListGroupItem,
                { key: item && item.id || index },
                React.createElement(SimpleView, { type: _this.props.itemType, value: item, onSave: _this.onSave,
                    onCancel: _this.onCancelEdit })
            );
        };

        var renderItem = function renderItem(item, index) {
            var isEditing = index === _this.state.indexEdited;
            return isEditing ? renderEditItem(item, index) : renderDisplayItem(item, index);
        };

        var newItem = '';
        var items = this.props.items.push(newItem);
        var listItems = items.map(renderItem);

        return React.createElement(
            ListGroup,
            null,
            listItems
        );
    },

    getInitialState: function getInitialState() {
        return {
            indexEdited: -1
        };
    },

    onEdit: function onEdit(index) {
        this.setState({ indexEdited: index });
    },

    onSave: function onSave(updatedItem) {
        var itemAddedAtEnd = this.state.indexEdited === this.props.items.size;
        var nextIndexEdited = itemAddedAtEnd ? this.props.items.size + 1 : this.getInitialState().indexEdited;

        if (this.props.onChangeList) {
            var updatedList = this.props.items.set(this.state.indexEdited, updatedItem).filter(function (item) {
                return item !== '' && item !== null;
            });
            this.props.onChangeList(updatedList);
        }
        this.setState({ indexEdited: nextIndexEdited });
    },

    onCancelEdit: function onCancelEdit() {
        this.setState(this.getInitialState());
    }
});

SimpleListEditable.propTypes = {
    items: PropTypes.instanceOf(List).isRequired,
    itemType: PropTypes.func.isRequired,
    onChangeList: PropTypes.func,
    addButtonPosition: PropTypes.string
};

module.exports = SimpleListEditable;