'use strict';

var _ = require('lodash');
var React = require('react');

var _require = require('react');

var PropTypes = _require.PropTypes;

var _require2 = require('react-bootstrap');

var Form = _require2.Form;
var Button = _require2.Button;

var FormItem = function FormItem() {
    return require('./FormItem');
};

var SimpleView = React.createClass({
    displayName: 'SimpleView',


    getInitialState: function getInitialState() {
        return {};
    },

    componentWillReceiveProps: function componentWillReceiveProps() {
        this.setState(this.getInitialState());
    },

    value: function value() {
        return this.isChanged() ? this.state.updatedValue : this.props.value;
    },

    isChanged: function isChanged() {
        return this.state.hasOwnProperty("updatedValue") && this.state.updatedValue !== this.props.value;
    },

    render: function render() {
        var FormItemClass = FormItem();
        return React.createElement(
            Form,
            { inline: true, onSubmit: function onSubmit(e) {
                    return e.preventDefault();
                }, onKeyUp: this.onKeyUp },
            React.createElement(FormItemClass, { type: this.props.type, editable: true, onChange: this.onChange, value: this.value(), label: null, autoFocus: true })
        );
    },

    onChange: function onChange(value) {
        this.setState({ updatedValue: value });
    },

    onSave: function onSave() {
        if (this.isChanged()) {
            var updatedValue = this.state.updatedValue;
            console.log('save', updatedValue);
            this.setState(this.getInitialState());
            this.props.onSave(updatedValue);
        } else {
            console.log('save', 'no change');
            this.setState(this.getInitialState());
            this.props.onCancel();
        }
    },

    onKeyUp: function onKeyUp(e) {
        var ESC = 27,
            ENTER = 13;
        if (e.keyCode === ESC) {
            this.props.onCancel();
        }
        if (e.keyCode === ENTER) {
            this.onSave();
        }
    }
});

SimpleView.propTypes = {
    value: PropTypes.any.isRequired,
    type: PropTypes.func.isRequired,
    onSave: PropTypes.func.isRequired,
    onCancel: PropTypes.func.isRequired
};

module.exports = SimpleView;